com.smartgwt.client.widgets.drawing

## Class DrawOval

- java.lang.Object
- - com.smartgwt.client.core.BaseClass
  - - com.smartgwt.client.widgets.drawing.DrawItem
    - - com.smartgwt.client.widgets.drawing.DrawOval

- All Implemented Interfaces:
    com.google.gwt.event.shared.HasHandlers, HasClickHandlers, HasDragMoveHandlers, HasDragResizeMoveHandlers, HasDragStartHandlers, HasDragStopHandlers, HasMouseDownHandlers, HasMouseMoveHandlers, HasMouseOutHandlers, HasMouseOverHandlers, HasMouseUpHandlers, HasMovedHandlers, HasResizedHandlers, HasShowContextMenuHandlers

      public class DrawOval
      extends DrawItem

  DrawItem subclass to render oval shapes, including circles.

- - ### Field Summary

    - ### Fields inherited from class com.smartgwt.client.core.BaseClass

      `config, id, scClassName`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DrawOval()`
    `DrawOval(com.google.gwt.core.client.JavaScriptObject jsObj)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `com.google.gwt.core.client.JavaScriptObject` | `create()`
    `Point` | `getCenterPoint()` Center point of the oval.
    `int` | `getHeight()` Height in pixels.
    `int` | `getLeft()` Left coordinate in pixels relative to the DrawPane.
    `static DrawOval` | `getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `int` | `getTop()` Top coordinate in pixels relative to the DrawPane.
    `int` | `getWidth()` Width in pixels.
    `void` | `moveBy(int dX, int dY)` Move the drawOval by the specified delta
    `void` | `moveTo(int left, int top)` Move the drawOval to the specified left/top position.
    `void` | `resizeBy(int dX, int dY)` Resize by the specified delta.
    `void` | `resizeTo(int width, int height)` Resize to the specified size.
    `void` | `setCenterPoint(Point centerPoint)` Center point of the oval.
    `static void` | `setDefaultProperties(DrawOval drawOvalProperties)` Class level method to set the default properties of this class.
    `void` | `setHeight(int height)` Height in pixels.
    `void` | `setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)`
    `void` | `setLeft(int left)` Left coordinate in pixels relative to the DrawPane.
    `void` | `setOval(int cx, int cy, int rx, int ry)` Resize and reposition the drawOval by setting its radius, and centerPoint.
    `void` | `setRadii(int rx, int ry)` Resize the drawOval by setting its horizontal and vertical radius, and retaining its current center point.
    `void` | `setRadius(java.lang.Integer radius)` Radius of the oval.
    `void` | `setRect(int left, int top, int width, int height)` Move and resize the drawOval to match the specified coordinates and size.
    `void` | `setTop(int top)` Top coordinate in pixels relative to the DrawPane.
    `void` | `setWidth(int width)` Width in pixels.

    - ### Methods inherited from class com.smartgwt.client.widgets.drawing.DrawItem

      `addClickHandler, addDragMoveHandler, addDragResizeMoveHandler, addDragStartHandler, addDragStopHandler, addMouseDownHandler, addMouseMoveHandler, addMouseOutHandler, addMouseOverHandler, addMouseUpHandler, addMovedHandler, addResizedHandler, addShowContextMenuHandler, computeAngle, computeAngleAsDouble, dragResizeMove, draw, erase, getAttributeAsIntArray, getBoundingBox, getCanDrag, getCanHover, getCenter, getContextMenu, getCursor, getDestroyed, getDestroying, getDragStartDistance, getDrawGroup, getDrawPane, getEndArrow, getFillColor, getFillGradient, getFillOpacity, getHoverHTML, getKeepInParentRect, getKnobs, getLineCap, getLineColor, getLineOpacity, getLinePattern, getLineWidth, getMoveKnobOffset, getMoveKnobPoint, getPageLeft, getPageTop, getPrompt, getRef, getResizeKnobPoints, getRotation, getScale, getShadow, getShowHover, getStartArrow, getSvgString, hide, hideKnobs, hover, isInBounds, isPointInPath, rotateBy, rotateBy, rotateTo, rotateTo, scaleBy, scaleBy, scaleTo, scaleTo, setAttribute, setCanDrag, setCanHover, setContextMenu, setCursor, setDefaultProperties, setDragStartDistance, setDrawGroup, setDrawPane, setEndArrow, setFillColor, setFillGradient, setFillOpacity, setKeepInParentRect, setKeepInParentRect, setKnobs, setLineCap, setLineColor, setLineOpacity, setLinePattern, setLineWidth, setMoveKnobOffset, setMoveKnobPoint, setPrompt, setResizeKnobPoints, setRotation, setScale, setShadow, setShowHover, setStartArrow, show, showKnobs`

    - ### Methods inherited from class com.smartgwt.client.core.BaseClass

      `asSGWTComponent, destroy, doAddHandler, doInit, error, error, errorIfNotCreated, fireEvent, getAttribute, getAttributeAsBoolean, getAttributeAsDate, getAttributeAsDouble, getAttributeAsElement, getAttributeAsFloat, getAttributeAsInt, getAttributeAsJavaScriptObject, getAttributeAsMap, getAttributeAsString, getAttributeAsStringArray, getClassName, getConfig, getHandlerCount, getID, getJsObj, getOrCreateJsObj, getScClassName, internalSetID, internalSetID, isCreated, onBind, onInit, registerID, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setAttribute, setID, setProperty, setProperty, setProperty, setProperty, setScClassName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.google.gwt.event.shared.HasHandlers

      `fireEvent`

- - ### Constructor Detail

    - #### DrawOval

          public DrawOval()

    - #### DrawOval

          public DrawOval(com.google.gwt.core.client.JavaScriptObject jsObj)

  - ### Method Detail

    - #### getOrCreateRef

          public static DrawOval getOrCreateRef(com.google.gwt.core.client.JavaScriptObject jsObj)

    - #### setJavaScriptObject

          public void setJavaScriptObject(com.google.gwt.core.client.JavaScriptObject jsObj)

      Overrides:
        `setJavaScriptObject` in class `DrawItem`

    - #### create

          public com.google.gwt.core.client.JavaScriptObject create()

      Overrides:
        `create` in class `DrawItem`

    - #### setCenterPoint

          public void setCenterPoint(Point centerPoint)

      Center point of the oval. If unset, derived from left/top/width/height.
      If this method is called after the component has been drawn/initialized: Change the center point for this oval.
      Parameters:
        `centerPoint` - left coordinate. Default value is null

    - #### getCenterPoint

          public Point getCenterPoint()

      Center point of the oval. If unset, derived from left/top/width/height.
      Returns:
        Point

    - #### setHeight

          public void setHeight(int height)

      Height in pixels.
      If this method is called after the component has been drawn/initialized: Set the height of the drawOval
      Parameters:
        `height` - new height. Default value is 100

    - #### getHeight

          public int getHeight()

      Height in pixels.
      Returns:
        int

    - #### setLeft

          public void setLeft(int left)

      Left coordinate in pixels relative to the DrawPane.
      If this method is called after the component has been drawn/initialized: Set the left coordinate of the drawOval
      Parameters:
        `left` - new left coordinate. Default value is 0

    - #### getLeft

          public int getLeft()

      Left coordinate in pixels relative to the DrawPane.
      Returns:
        int

    - #### setRadius

          public void setRadius(java.lang.Integer radius)

      Radius of the oval. If unset, horizontal and vertical radii are derived from width and height
      If this method is called after the component has been drawn/initialized: Resize the drawOval by setting its radius, and retaining its current center point.
      Parameters:
        `radius` - new radius. This will be applied on both axes, meaning calling this method will always result in the drawOval being rendered as a circle. Default value is null

    - #### setTop

          public void setTop(int top)

      Top coordinate in pixels relative to the DrawPane.
      If this method is called after the component has been drawn/initialized: Set the top coordinate of the drawOval
      Parameters:
        `top` - new top coordinate. Default value is 0

    - #### getTop

          public int getTop()

      Top coordinate in pixels relative to the DrawPane.
      Returns:
        int

    - #### setWidth

          public void setWidth(int width)

      Width in pixels.
      If this method is called after the component has been drawn/initialized: Set the width of the drawOval
      Parameters:
        `width` - new width. Default value is 100

    - #### getWidth

          public int getWidth()

      Width in pixels.
      Returns:
        int

    - #### moveBy

          public void moveBy(int dX,
                    int dY)

      Move the drawOval by the specified delta
      Overrides:
        `moveBy` in class `DrawItem`
      Parameters:
        `dX` - number of pixels to move horizontally
        `dY` - number of pixels to move vertically

    - #### moveTo

          public void moveTo(int left,
                    int top)

      Move the drawOval to the specified left/top position. You may also call `DrawOval.setCenterPoint` to reposition the oval around a new center position.
      Parameters:
        `left` - new left coordinate
        `top` - new top coordinate

    - #### resizeBy

          public void resizeBy(int dX,
                      int dY)

      Resize by the specified delta. Note that the resize will occur from the current top/left coordinates, meaning the center positon of the oval may change. You may also use `DrawOval.setRadii` to change the radius in either direction without modifying the centerpoint.
      Overrides:
        `resizeBy` in class `DrawItem`
      Parameters:
        `dX` - number of pixels to resize by horizontally
        `dY` - number of pixels to resize by vertically

    - #### resizeTo

          public void resizeTo(int width,
                      int height)

      Resize to the specified size. Note that the resize will occur from the current top/left coordinates, meaning the center positon of the oval may change. You may also use `DrawOval.setRadii` to change the radius in either direction without modifying the centerpoint.
      Overrides:
        `resizeTo` in class `DrawItem`
      Parameters:
        `width` - new width
        `height` - new height

    - #### setOval

          public void setOval(int cx,
                     int cy,
                     int rx,
                     int ry)

      Resize and reposition the drawOval by setting its radius, and centerPoint.
      Parameters:
        `cx` - new horizontal center point coordinate
        `cy` - new vertical center point coordinate
        `rx` - new horizontal radius
        `ry` - new vertical radius

    - #### setRadii

          public void setRadii(int rx,
                      int ry)

      Resize the drawOval by setting its horizontal and vertical radius, and retaining its current center point.
      Parameters:
        `rx` - new horizontal radius
        `ry` - new vertical radius

    - #### setRect

          public void setRect(int left,
                     int top,
                     int width,
                     int height)

      Move and resize the drawOval to match the specified coordinates and size.
      Parameters:
        `left` - new left coordinate
        `top` - new top coordinate
        `width` - new width
        `height` - new height

    - #### setDefaultProperties

          public static void setDefaultProperties(DrawOval drawOvalProperties)

      Class level method to set the default properties of this class. If set, then all subsequent instances of this class will automatically have the default properties that were set when this method was called. This is a powerful feature that eliminates the need for users to create a separate hierarchy of subclasses that only alter the default properties of this class. Can also be used for skinning / styling purposes.

      Note: This method is intended for setting default attributes only and will effect all instances of the underlying class (including those automatically generated in JavaScript). This method should not be used to apply standard EventHandlers or override methods for a class - use a custom subclass instead.

      Parameters:
        `drawOvalProperties` - properties that should be used as new defaults when instances of this class are created